VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "cRegistry"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

' Access Rights
Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_SET_VALUE = &H2
Private Const KEY_CREATE_SUB_KEY = &H4
Private Const KEY_ENUMERATE_SUB_KEYS = &H8
Private Const KEY_NOTIFY = &H10
Private Const KEY_CREATE_LINK = &H20
Private Const KEY_ALL_ACCESS = &H3F

' Registry Options
Private Const REG_OPTION_NON_VOLATILE = 0&
Private Const REG_OPTION_VOLATILE = &H1

' Disposition
Private Const REG_CREATED_NEW_KEY = &H1
Private Const REG_OPENED_EXISTING_KEY = &H2

' Masks for the predefined standard access types
Private Const STANDARD_RIGHTS_ALL = &H1F0000
Private Const SPECIFIC_RIGHTS_ALL = &HFFFF

' Error Codeds
Private Const ERROR_SUCCESS = 0&
Private Const ERROR_ACCESS_DENIED = 5
Private Const ERROR_INVALID_DATA = 13&
Private Const ERROR_MORE_DATA = 234 '  dderror
Private Const ERROR_NO_MORE_ITEMS = 259

' Structures for Registry Security
Private Type SECURITY_ATTRIBUTES
  nLength As Long
  lpSecurityDescriptor As Long
  bInheritHandle As Boolean
End Type

Private Type FILETIME
  dwLowDateTime As Long
  dwHighDateTime As Long
End Type

'Registry Function Prototypes
Private Declare Function RegOpenKeyEx Lib "advapi32" Alias "RegOpenKeyExA" _
  (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, _
  ByVal samDesired As Long, phkResult As Long) As Long

Private Declare Function RegSetValueExStr Lib "advapi32" Alias "RegSetValueExA" _
  (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, _
   ByVal dwType As Long, ByVal szData As String, ByVal cbData As Long) As Long
Private Declare Function RegSetValueExLong Lib "advapi32" Alias "RegSetValueExA" _
  (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, _
   ByVal dwType As Long, szData As Long, ByVal cbData As Long) As Long
Private Declare Function RegSetValueExByte Lib "advapi32" Alias "RegSetValueExA" _
  (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, _
   ByVal dwType As Long, szData As Byte, ByVal cbData As Long) As Long

Private Declare Function RegCloseKey Lib "advapi32" (ByVal hKey As Long) As Long

Private Declare Function RegQueryValueExStr Lib "advapi32" Alias "RegQueryValueExA" _
  (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, _
   ByRef lpType As Long, ByVal szData As String, ByRef lpcbData As Long) As Long
Private Declare Function RegQueryValueExLong Lib "advapi32" Alias "RegQueryValueExA" _
  (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, _
   ByRef lpType As Long, szData As Long, ByRef lpcbData As Long) As Long
Private Declare Function RegQueryValueExByte Lib "advapi32" Alias "RegQueryValueExA" _
  (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, _
   ByRef lpType As Long, szData As Byte, ByRef lpcbData As Long) As Long
   
Private Declare Function RegCreateKeyEx Lib "advapi32" Alias "RegCreateKeyExA" _
  (ByVal hKey As Long, ByVal lpSubKey As String, ByVal Reserved As Long, _
   ByVal lpClass As String, ByVal dwOptions As Long, ByVal samDesired As Long, _
   lpSecurityAttributes As SECURITY_ATTRIBUTES, phkResult As Long, _
   lpdwDisposition As Long) As Long

Private Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" _
  (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, _
   lpcbName As Long, ByVal lpReserved As Long, ByVal lpClass As String, _
   lpcbClass As Long, lpftLastWriteTime As FILETIME) As Long

Private Declare Function RegEnumKey Lib "advapi32.dll" Alias "RegEnumKeyA" ( _
    ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpName As String, _
    ByVal cbName As Long) As Long

Private Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" _
  (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, _
   lpcbValueName As Long, ByVal lpReserved As Long, ByVal lpType As Long, _
   ByVal lpData As Long, ByVal lpcbData As Long) As Long
   
Private Declare Function RegEnumValueLong Lib "advapi32.dll" Alias "RegEnumValueA" _
  (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, _
   lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, _
   lpData As Long, lpcbData As Long) As Long
Private Declare Function RegEnumValueStr Lib "advapi32.dll" Alias "RegEnumValueA" _
  (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, _
   lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, _
   ByVal lpData As String, lpcbData As Long) As Long
Private Declare Function RegEnumValueByte Lib "advapi32.dll" Alias "RegEnumValueA" _
  (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpValueName As String, _
   lpcbValueName As Long, ByVal lpReserved As Long, lpType As Long, _
   lpData As Byte, lpcbData As Long) As Long

Private Declare Function RegQueryInfoKey Lib "advapi32.dll" Alias "RegQueryInfoKeyA" _
   (ByVal hKey As Long, ByVal lpClass As String, _
   lpcbClass As Long, ByVal lpReserved As Long, lpcSubKeys As Long, _
   lpcbMaxSubKeyLen As Long, lpcbMaxClassLen As Long, lpcValues As Long, _
   lpcbMaxValueNameLen As Long, lpcbMaxValueLen As Long, lpcbSecurityDescriptor As Long, _
   lpftLastWriteTime As Any) As Long

Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" _
  (ByVal hKey As Long, ByVal lpSubKey As String) As Long

Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" _
  (ByVal hKey As Long, ByVal lpValueName As String) As Long

' Other declares:
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" ( _
    lpvDest As Any, lpvSource As Any, ByVal cbCopy As Long)
Private Declare Function ExpandEnvironmentStrings Lib "kernel32" Alias "ExpandEnvironmentStringsA" (ByVal lpSrc As String, ByVal lpDst As String, ByVal nSize As Long) As Long


Public Enum ERegistryClassConstants
    HKEY_CLASSES_ROOT = &H80000000
    HKEY_CURRENT_USER = &H80000001
    HKEY_LOCAL_MACHINE = &H80000002
    HKEY_USERS = &H80000003
End Enum

Public Enum ERegistryValueTypes
'Predefined Value Types
    REG_NONE = (0)                         'No value type
    REG_SZ = (1)                           'Unicode nul terminated string
    REG_EXPAND_SZ = (2)                    'Unicode nul terminated string w/enviornment var
    REG_BINARY = (3)                       'Free form binary
    REG_DWORD = (4)                        '32-bit number
    REG_DWORD_LITTLE_ENDIAN = (4)          '32-bit number (same as REG_DWORD)
    REG_DWORD_BIG_ENDIAN = (5)             '32-bit number
    REG_LINK = (6)                         'Symbolic Link (unicode)
    REG_MULTI_SZ = (7)                     'Multiple Unicode strings
    REG_RESOURCE_LIST = (8)                'Resource list in the resource map
    REG_FULL_RESOURCE_DESCRIPTOR = (9)     'Resource list in the hardware description
    REG_RESOURCE_REQUIREMENTS_LIST = (10)
End Enum

Private m_hClassKey         As Long
Private m_strSectionKey     As String
Private m_strValueKey       As String
Private m_varValue          As Variant
Private m_strSetValue       As String
Private m_varDefault        As Variant
Private m_eValueType        As ERegistryValueTypes

Public Property Get KeyExists() As Boolean
Attribute KeyExists.VB_Description = "Returns whether or not the current registry key exists"
    
    Dim hKey        As Long
    If RegOpenKeyEx(m_hClassKey, m_strSectionKey, 0, 1, hKey) = ERROR_SUCCESS Then
        KeyExists = True
        RegCloseKey hKey
    Else
        KeyExists = False
    End If
    
End Property
Public Function CreateKey() As Boolean
Attribute CreateKey.VB_Description = "Creates the specified registry key"
    Dim udtSA       As SECURITY_ATTRIBUTES
    Dim hKey        As Long
    Dim lngCreate   As Long
    Dim lngError    As Long

    'Open or Create the key
    lngError = RegCreateKeyEx(m_hClassKey, m_strSectionKey, 0, "", REG_OPTION_NON_VOLATILE, _
                 KEY_ALL_ACCESS, udtSA, hKey, lngCreate)
    If lngError Then
        Err.Raise 26001, App.EXEName & ".cRegistry", "Failed to create registry Key: '" & m_strSectionKey
    Else
        CreateKey = (lngError = ERROR_SUCCESS)
        'Close the key
        RegCloseKey hKey
    End If
End Function
Public Function DeleteKey() As Boolean
Attribute DeleteKey.VB_Description = "Deletes the specified registry key"
Dim e As Long
    e = RegDeleteKey(m_hClassKey, m_strSectionKey)
    If e Then
        Err.Raise 26001, App.EXEName & ".cRegistry", "Failed to delete registry Key: '" & m_hClassKey & "',Section: '" & m_strSectionKey
    Else
        DeleteKey = (e = ERROR_SUCCESS)
    End If
    
End Function
Public Function DeleteValue() As Boolean
Attribute DeleteValue.VB_Description = "Deletes the specified registry key value"
    Dim lngError    As Long
    Dim hKey        As Long

    lngError = RegOpenKeyEx(m_hClassKey, m_strSectionKey, 0, KEY_ALL_ACCESS, hKey)
    If lngError Then
        Err.Raise 26001, App.EXEName & ".cRegistry", "Failed to open key '" & m_hClassKey & "',Section: '" & m_strSectionKey & "' for delete access"
    Else
        lngError = RegDeleteValue(hKey, m_strValueKey)
        If lngError Then
            Err.Raise 26001, App.EXEName & ".cRegistry", "Failed to delete registry Key: '" & m_hClassKey & "',Section: '" & m_strSectionKey & "',Key: '" & m_strValueKey
        Else
            DeleteValue = (lngError = ERROR_SUCCESS)
        End If
    End If

End Function
Public Property Get Value() As Variant
Attribute Value.VB_Description = "Returns/Sets the value of the current registry key"
Dim vValue As Variant
Dim cData As Long, sData As String, ordType As Long, e As Long
Dim hKey As Long

    e = RegOpenKeyEx(m_hClassKey, m_strSectionKey, 0, KEY_QUERY_VALUE, hKey)
    'ApiRaiseIfe

    e = RegQueryValueExLong(hKey, m_strValueKey, 0&, ordType, 0&, cData)
    If e And e <> ERROR_MORE_DATA Then
        Value = m_varDefault
        Exit Property
    End If
    
    m_eValueType = ordType
    Select Case ordType
    Case REG_DWORD, REG_DWORD_LITTLE_ENDIAN
        Dim iData As Long
        e = RegQueryValueExLong(hKey, m_strValueKey, 0&, _
                               ordType, iData, cData)
        vValue = CLng(iData)
        
    Case REG_DWORD_BIG_ENDIAN  ' Unlikely, but you never know
        Dim dwData As Long
        e = RegQueryValueExLong(hKey, m_strValueKey, 0&, _
                               ordType, dwData, cData)
        vValue = SwapEndian(dwData)
        
    Case REG_SZ, REG_MULTI_SZ ' Same thing to Visual Basic
        sData = String$(cData - 1, 0)
        e = RegQueryValueExStr(hKey, m_strValueKey, 0&, _
                               ordType, sData, cData)
        vValue = sData
        
    Case REG_EXPAND_SZ
        sData = String$(cData - 1, 0)
        e = RegQueryValueExStr(hKey, m_strValueKey, 0&, _
                               ordType, sData, cData)
        vValue = ExpandEnvStr(sData)
        
    ' Catch REG_BINARY and anything else
    Case Else
        Dim abData() As Byte
        ReDim abData(cData)
        e = RegQueryValueExByte(hKey, m_strValueKey, 0&, _
                                ordType, abData(0), cData)
        vValue = abData
        
    End Select
    Value = vValue
    
End Property
Public Property Let Value( _
        ByVal vValue As Variant _
    )
Dim ordType As Long
Dim c As Long
Dim hKey As Long
Dim e As Long
Dim lCreate As Long
Dim tSA As SECURITY_ATTRIBUTES

    'Open or Create the key
    e = RegCreateKeyEx(m_hClassKey, m_strSectionKey, 0, "", REG_OPTION_NON_VOLATILE, _
                 KEY_ALL_ACCESS, tSA, hKey, lCreate)
    
    If e Then
        Err.Raise 26001, App.EXEName & ".cRegistry", "Failed to set registry value Key: '" & m_hClassKey & "',Section: '" & m_strSectionKey & "',Key: '" & m_strValueKey & "' to value: '" & m_varValue & "'"
    Else

        Select Case m_eValueType
        Case REG_BINARY
            If (VarType(vValue) = vbArray + vbByte) Then
                Dim ab() As Byte
                ab = vValue
                ordType = REG_BINARY
                c = UBound(ab) - LBound(ab) - 1
                e = RegSetValueExByte(hKey, m_strValueKey, 0&, ordType, ab(0), c)
            Else
                Err.Raise 26001
            End If
        Case REG_DWORD, REG_DWORD_BIG_ENDIAN, REG_DWORD_LITTLE_ENDIAN
            If (VarType(vValue) = vbInteger) Or (VarType(vValue) = vbLong) Then
                Dim i As Long
                i = vValue
                ordType = REG_DWORD
                e = RegSetValueExLong(hKey, m_strValueKey, 0&, ordType, i, 4)
            End If
        Case REG_SZ, REG_EXPAND_SZ
            Dim s As String, iPos As Long
            s = vValue
            ordType = REG_SZ
            ' Assume anything with two non-adjacent percents is expanded string
            iPos = InStr(s, "%")
            If iPos Then
                If InStr(iPos + 2, s, "%") Then ordType = REG_EXPAND_SZ
            End If
            c = Len(s) + 1
            e = RegSetValueExStr(hKey, m_strValueKey, 0&, ordType, s, c)
            
        ' User should convert to a compatible type before calling
        Case Else
            e = ERROR_INVALID_DATA
            
        End Select
        
        If Not e Then
            m_varValue = vValue
        Else
            Err.Raise vbObjectError + 1048 + 26001, App.EXEName & ".cRegistry", "Failed to set registry value Key: '" & m_hClassKey & "',Section: '" & m_strSectionKey & "',Key: '" & m_strValueKey & "' to value: '" & m_varValue & "'"
        End If
        
        'Close the key
        RegCloseKey hKey
    
    End If
    
End Property
Public Function EnumerateValues( _
        ByRef strKeyNames() As String, _
        ByRef lngKeyCount As Long _
    ) As Boolean
Attribute EnumerateValues.VB_Description = "Enumerate through all of the values of the specified registry key"
    
    Dim lngResult       As Long
    Dim hKey            As Long
    Dim strName         As String
    Dim lngNameSize     As Long
    Dim strData         As String
    Dim lngIndex        As Long
    Dim lngJunk         As Long
    Dim lngNameMax      As Long
    Dim curFt           As Currency

    lngKeyCount = 0
    Erase strKeyNames()
     
    lngIndex = 0
    lngResult = RegOpenKeyEx(m_hClassKey, m_strSectionKey, 0, KEY_QUERY_VALUE, hKey)
    If (lngResult = ERROR_SUCCESS) Then

       lngResult = RegQueryInfoKey(hKey, "", lngJunk, 0, _
                                lngJunk, lngJunk, lngJunk, lngJunk, _
                                lngNameMax, lngJunk, lngJunk, curFt)
        Do While lngResult = ERROR_SUCCESS
    
            'Set buffer space
            lngNameSize = lngNameMax + 1
            strName = String$(lngNameSize, 0)
            If (lngNameSize = 0) Then lngNameSize = 1
            
            'Get value name:
            lngResult = RegEnumValue(hKey, lngIndex, strName, lngNameSize, _
                                   0&, 0&, 0&, 0&)
            If (lngResult = ERROR_SUCCESS) Then
        
                 ' Although in theory you can also retrieve the actual
                 ' value and type here, I found it always (ultimately) resulted in
                 ' a GPF, on Win95 and NT.  Why?  Can anyone help?
        
                strName = Left$(strName, lngNameSize)
                  
                lngKeyCount = lngKeyCount + 1
                ReDim Preserve strKeyNames(1 To lngKeyCount) As String
                strKeyNames(lngKeyCount) = strName
            End If
            lngIndex = lngIndex + 1
        Loop
    End If
    If (hKey <> 0) Then
       RegCloseKey hKey
    End If
    
    EnumerateValues = True
    Exit Function
    
EnumerateValuesError:
    If (hKey <> 0) Then
       RegCloseKey hKey
    End If
    Err.Raise vbObjectError + 1048 + 26003, App.EXEName & ".cRegistry", Err.Description
    Exit Function

End Function
Public Function EnumerateSections( _
        ByRef sSect() As String, _
        ByRef iSectCount As Long _
    ) As Boolean
Attribute EnumerateSections.VB_Description = "Enumerate through all of the section of the specified registry key"
    
    Dim lngResult       As Long
    Dim hKey            As Long
    Dim dwReserved      As Long
    Dim strBuffer       As String
    Dim lngBufferSize   As Long
    Dim lngIndex        As Long
    Dim lngType         As Long
    Dim strCompKey      As String
    Dim lngPos          As Long

    
    On Error GoTo EnumerateSectionsError

    iSectCount = 0
    Erase sSect

    lngIndex = 0

    lngResult = RegOpenKeyEx(m_hClassKey, m_strSectionKey, 0, KEY_ENUMERATE_SUB_KEYS, hKey)
    Do While lngResult = ERROR_SUCCESS
        'Set buffer space
        strBuffer = String$(255, 0)
        lngBufferSize = Len(strBuffer)
       
       'Get next value
        lngResult = RegEnumKey(hKey, lngIndex, strBuffer, lngBufferSize)
                              
        If (lngResult = ERROR_SUCCESS) Then
            iSectCount = iSectCount + 1
            ReDim Preserve sSect(1 To iSectCount) As String
            lngPos = InStr(strBuffer, Chr$(0))
            If (lngPos > 0) Then
               sSect(iSectCount) = Left(strBuffer, lngPos - 1)
            Else
               sSect(iSectCount) = Left(strBuffer, lngBufferSize)
            End If
        End If
        
        lngIndex = lngIndex + 1
    Loop
    If (hKey <> 0) Then
       RegCloseKey hKey
    End If
    EnumerateSections = True
    Exit Function
    
EnumerateSectionsError:
    If (hKey <> 0) Then
       RegCloseKey hKey
    End If
    Err.Raise vbObjectError + 1048 + 26002, App.EXEName & ".cRegistry", Err.Description
    Exit Function
End Function
Public Sub CreateEXEAssociation( _
        ByVal sExePath As String, _
        ByVal sClassName As String, _
        ByVal sClassDescription As String, _
        ByVal sAssociation As String, _
        Optional ByVal lDefaultIconIndex As Long = -1 _
    )
Attribute CreateEXEAssociation.VB_Description = "Creates an file association "
    ClassKey = HKEY_CLASSES_ROOT
    SectionKey = "." & sAssociation
    ValueKey = ""
    Value = sClassName
    SectionKey = "." & sAssociation & "\shell\open\command"
    ValueKey = ""
    Value = sExePath & " ""%1"""
    
    SectionKey = sClassName
    ValueKey = ""
    Value = sClassDescription
    SectionKey = sClassName & "\shell\open\command"
    ValueKey = sExePath & " ""%1"""
    If lDefaultIconIndex > -1 Then
        SectionKey = sClassName & "\DefaultIcon"
        ValueKey = ""
        Value = sExePath & "," & CStr(lDefaultIconIndex)
    End If
    
End Sub
Public Property Get ValueType() As ERegistryValueTypes
Attribute ValueType.VB_Description = "Returns/Sets the data type of the current registry key"
    ValueType = m_eValueType
End Property
Public Property Let ValueType(ByVal eValueType As ERegistryValueTypes)
    m_eValueType = eValueType
End Property
Public Property Get ClassKey() As ERegistryClassConstants
Attribute ClassKey.VB_Description = "Returns/Sets the class key for the current registry key"
    ClassKey = m_hClassKey
End Property
Public Property Let ClassKey( _
        ByVal eKey As ERegistryClassConstants)
    m_hClassKey = eKey
End Property
Public Property Get SectionKey() As String
Attribute SectionKey.VB_Description = "Returns/Sets the section of the current registry key"
    SectionKey = m_strSectionKey
End Property
Public Property Let SectionKey( _
        ByVal sSectionKey As String _
    )
    m_strSectionKey = sSectionKey
End Property
Public Property Get ValueKey() As String
Attribute ValueKey.VB_Description = "Returns/Sets the registry key value"
    ValueKey = m_strValueKey
End Property
Public Property Let ValueKey( _
        ByVal sValueKey As String _
    )
    m_strValueKey = sValueKey
End Property
Public Property Get Default() As Variant
Attribute Default.VB_Description = "Returns/Sets the default value of the current registry key"
    Default = m_varDefault
End Property
Public Property Let Default( _
        ByVal vDefault As Variant _
    )
    m_varDefault = vDefault
End Property
Private Function SwapEndian(ByVal dw As Long) As Long
    CopyMemory ByVal VarPtr(SwapEndian) + 3, dw, 1
    CopyMemory ByVal VarPtr(SwapEndian) + 2, ByVal VarPtr(dw) + 1, 1
    CopyMemory ByVal VarPtr(SwapEndian) + 1, ByVal VarPtr(dw) + 2, 1
    CopyMemory SwapEndian, ByVal VarPtr(dw) + 3, 1
End Function
Private Function ExpandEnvStr(sData As String) As String
    Dim lngTemp     As Long
    Dim strTemp     As String
    ' Get the length
    strTemp = "" ' Needed to get around Windows 95 limitation
    lngTemp = ExpandEnvironmentStrings(sData, strTemp, lngTemp)
    ' Expand the string
    strTemp = String$(lngTemp - 1, 0)
    lngTemp = ExpandEnvironmentStrings(sData, strTemp, lngTemp)
    ExpandEnvStr = strTemp
End Function
